# YAML Example : interactive multistages 2G analysis

## Setup

Copy the example files to the working directory

```bash
mkdir MultiStages2G_yaml
cd MultiStages2G_yaml
pycwb_gen_config --cwb_install <path to cwb install> --cwb_source <path to cwb source> --work_dir <path to work dir>
ipython
```

modify `config/config.ini` with your own setup

Initialize ROOT with class `pycWB` 

```python
from pycwb import pycWB

cwb = pycWB('./config.ini') # load envs and create dirs
ROOT = cwb.ROOT
gROOT = cwb.gROOT
```

Run the setup to create frame file
```python
from pycwb import sim
sim.create_frame_noise(gROOT, ROOT)
sim.setup_sim_data(['H1','L1','V1'])
```

## INIT STAGE

```python
cwb.cwb_inet2G(1,'user_parameters.yaml', 'FULL')
```